﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win;
using Infragistics.Win.UltraMessageBox;

namespace UltraGirdWithSummaryPadding
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            uiElementViewerDialog1.Show();
            ultraGrid1.CreationFilter = new CreatingTextUIElement(6, ultraGrid1);
            ultraGrid1.DisplayLayout.Bands[0].Summaries[0].Lines = 1;
        }

    }

    public class CreatingTextUIElement : IUIElementCreationFilter
    {
        private int padding;
        private UltraGrid grid;
        public CreatingTextUIElement(int Padding, UltraGrid Grid)
        {
            this.padding = Padding;
            this.grid  =Grid;
        }

        public void AfterCreateChildElements(UIElement parent)
        {
            SummaryValueUIElement El = parent as SummaryValueUIElement;
            if (El != null)
            {
                if (El.HasChildElements)
                {
                    TextUIElement textElement = El.ChildElements[0] as TextUIElement;
                    textElement.WrapText = true;
                    if(textElement.GetLineCount()<9) grid.DisplayLayout.Bands[0].Summaries[0].Lines = textElement.GetLineCount();
                    
                    // Uncomment these two lines.
                    // This is option 2
                    //El.Rect = new Rectangle(El.Rect.X, El.Rect.Y, grid.Width - textElement.Rect.X, El.Rect.Height);
                    //textElement.Rect = new Rectangle(textElement.Rect.X, textElement.Rect.Y, grid.Width - textElement.Rect.X, textElement.Rect.Height);
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
